---
title: ContentIndex.delete()
slug: Web/API/ContentIndex/delete
tags:
  - Content
  - Content Index API
  - Index
  - Interface
  - Method
  - PWA
  - content index
  - content indexing
  - delete
---
<div>{{draft}}{{DefaultAPISidebar("Content Index API")}}</div>

<p class="summary">The <strong><code>delete()</code></strong> method of the {{domxref("ContentIndex")}} interface unregisters an item from the currently indexed content.</p>

<div class="note">
<p>Calling <code>delete()</code> only affects the index. It does not delete anything from the {{domxref('Cache')}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">ContentIndex.delete(<var>id</var>).then(...);</pre>

<h3 id="Parameters">Parameters</h3>

<p>This method receives no parameters.</p>

<h3 id="Return_value">Return value</h3>

<p>Returns a {{jsxref("Promise")}} that resolves with <code>undefined</code></p>

<h3 id="Exceptions">Exceptions</h3>

<p>No exceptions are thrown.</p>

<h2 id="Examples">Examples</h2>

<p>Below is an asynchronous function, that removes an item from the {{domxref('Content Index API','content index')}}. We receive a reference to the current {{domxref('ServiceWorkerRegistration')}}, which allows us to access the {{domxref('ServiceWorkerRegistration.index','index')}} property and thus access the <code>delete</code> method.</p>

<pre class="brush: js notranslate">async function unregisterContent(article) {

  // reference registration
  const registration = await navigator.serviceWorker.ready;

  // feature detect Content Index
  if (!registration.index)
    return;

  // unregister content from index
  await registration.index.delete(article.id);
}
</pre>

<p>The <code>delete</code> method can also be used within the {{domxref('ServiceWorker','service worker')}} scope.</p>

<pre class="brush: js notranslate">self.registration.index.delete('my-id');
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Content Index API','#content-index-delete','delete')}}</td>
   <td>{{Spec2('Content Index API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ContentIndex.delete")}}</p>

<h2 id="See_also">See also:</h2>

<ul>
 <li><a href="https://web.dev/content-indexing-api/">An introductory article on the Content Index API</a></li>
 <li><a href="https://contentindex.dev/">An app which uses the Content Index API to list and remove 'save for later' content</a></li>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API, along with information about Cache and CacheStorage</a></li>
</ul>
